import 'dart:math';

List<List<T>> chunk<T>(final List<T> list, [final int size = 1]) {
  assert(list != null && size > 0);

  if (list.isEmpty) {
    return [];
  }

  final List<List<T>> result = List((list.length / size).ceil());
  int index = 0;
  int resultIndex = 0;
  while(index < list.length) {
    result[resultIndex] = list.sublist(index, min(index + size, list.length));
    index += size;
    resultIndex += 1;
  }

  return result;
}
