import '_helper.dart';
import 'difference.dart';

List<T> differenceBy<T>(List<T> list, List<T> values, [Iteratee<T> iteratee]) {
  assert(list != null && values != null);

  if (iteratee == null) {
    return difference<T>(list, values);
  }

  final List<T> result = [];
  final Set set = Set.from(
    values.map((item) => iteratee(item))
  );
  list.forEach((value) {
    var v = iteratee(value);
    if (set.contains(v) == false) {
      result.add(value);
    }
  });
  
  return result;
}