import '_helper.dart';
import 'difference.dart';

List<T> differenceWith<T>(List<T> list, List<T> values, [Comparator<T> comparator]) {
  assert(list != null && values != null);

  if (comparator == null) {
    return difference<T>(list, values);
  }

  final List<T> result = [];

  outer:
  for (int i = 0; i < list.length; i++) {
    for (int j = 0; j < values.length; j++) {
      if (comparator(list[i], values[j])) {
        continue outer;
      }
    }
    result.add(list[i]);
  }
  
  return result;
}
