import '_helper.dart';

List<T> dropRightWhile<T>(List<T> list, [Predicator<T> predicator]) {
  assert(list != null);

  if (predicator == null) {
    predicator = (T value, [int index, List<T> list]) {
      return isFalsy(value);
    };
  }

  final int len = list.length;
  int end = len - 1;
  while(end >= 0 && predicator(list[end], end, list)) {
    end -= 1;
  }

  return list.sublist(0, end + 1);
}
