import '_helper.dart';

List<T> dropWhile<T>(List<T> list, [Predicator<T> predicator]) {
  assert(list != null);

  if (predicator == null) {
    predicator = (T value, [int index, List<T> list]) {
      return isFalsy(value);
    };
  }

  final int len = list.length;
  int start = 0;
  do {
    start += 1;
  } while(start < len && predicator(list[start], start, list));

  return list.sublist(start, len);
}
