import '_helper.dart';

bool every<T>(Iterable<T> it, [Predicator<T> predicatee]) {
  assert(it != null);

  if (predicatee == null) {
    predicatee = (T value, [int index, Iterable<T> it]) {
      return isFalsy(value) == false;
    };
  }

  int index = -1;
  for (T value in it) {
    index += 1;
    if (predicatee(value, index, it) == false) {
      return false;
    }
  }

  return true;
}
