import '_helper.dart';

bool everyForMap<K, V>(Map<K, V> map, [PredicatorForMap<K, V> predicatee]) {
  assert(map != null);

  if (predicatee == null) {
    predicatee = (V value, [K key, Map<K, V> map]) {
      return isFalsy(value) == false;
    };
  }
  
  for (K key in map.keys) {
    if (predicatee(map[key], key, map) == false) {
      return false;
    }
  }

  return true;
}
