import '_helper.dart';

List<V> filterForMap<K, V>(Map<K, V> map, [PredicatorForMap<K, V> predicatee]) {
  assert(map != null);

  if (predicatee == null) {
    predicatee = (V value, [K key, Map<K, V> map]) {
      return isFalsy(value) == false;
    };
  }

  final List<V> result = [];
  final List<K> keys = map.keys;

  for (int i = 0; i < keys.length; i++) {
    K key = keys[i];
    if (predicatee(map[key], key, map)) {
      result.add(map[key]);
    }
  }

  return result;
}
