import '_helper.dart';

V find<K, V>(Map<K, V> map, PredicatorForMap<K, V> predicate, [int fromIndex = 0]) {
  assert(map != null && predicate != null);

  final List<K> keys = map.keys;
  if (fromIndex >= keys.length) {
    return null;
  }
  if (fromIndex == null || fromIndex < 0) {
    fromIndex = 0;
  }
  
  K key;
  for (int i = fromIndex; i < keys.length; i++) {
    key = keys[i];
    if (predicate(map[key], key, map)) {
      return map[key];
    }
  }

  return null;
}
