import '_helper.dart';

V find<K, V>(Map<K, V> map, PredicatorForMap<K, V> predicate, [int fromIndex = 0]) {
  assert(map != null && predicate != null);

  if (fromIndex < 0) {
    return null;
  }
  final List<K> keys = map.keys;
  if (fromIndex == null || fromIndex >= keys.length) {
    fromIndex = keys.length - 1;
  }
  
  K key;
  for (int i = fromIndex; i >= 0; i--) {
    key = keys[i];
    if (predicate(map[key], key, map)) {
      return map[key];
    }
  }

  return null;
}
