List _flattenDepth(List list, int currentDepth, int maxDepth) {
  if (maxDepth != -1 && currentDepth > maxDepth) {
    return list.sublist(0, list.length);
  }
  final List result = [];
  for (int i = 0; i < list.length; i++) {
    if (list[i] is List) {
      result.addAll(
        _flattenDepth(list[i], currentDepth + 1, maxDepth)
      );
    } else {
      result.add(list[i]);
    }
  }

  return result;
}

List flatten(List list, [int depth = 1]) {
  assert(list != null && depth >= -1);

  final int len = list.length;

  if (depth == 0) {
    return list.sublist(0, len);
  }

  return _flattenDepth(list, 1, depth);
}
