import '_helper.dart';
import 'pullAll.dart';

List<T> pullAllBy<T>(List<T> list, [List<T> values, Iteratee<T> iteratee]) {
  assert(list != null);

  if (values == null || values.isEmpty) {
    return list;
  }
  if (iteratee == null) {
    return pullAll<T>(list, values);
  }

  final Map<dynamic, T> map = Map.fromIterable(
    list,
    key: (item) => iteratee(item),
    value: (item) => item
  );
  values.forEach((value) {
    var v = iteratee(value);
    if (map.containsKey(v)) {
      map.remove(v);
    }
  });
  
  return map.values.toList();
}
