typedef T _Iteratee<T>(accumulator, value, int index, List list);

T reduceRight<T>(List list, _Iteratee iteratee, [accumulator]) {
  assert(list != null);

  if (list.isEmpty) {
    return null;
  }
  if (list.length == 1) {
    return list[0];
  }

  int i = list.length - 1;
  if (accumulator == null) {
    accumulator = list[i];
    i -= 1;
  }

  T result = accumulator;
  for (; i >= 0; i--) {
    result = iteratee(result, list[i], i, list);
  }

  return result;
}
