import 'dart:math';

List<T> shuffle<T>(List<T> list) {
  assert(list != null);

  if (list.isEmpty) {
    return [];
  }

  final Random random = Random();
  final int len = list.length;
  int index = -1;
  final lastIndex = len - 1;
  final List<T> result = list.sublist(0, len);

  while(++index < len) {
    final int rand = index + random.nextInt(lastIndex - index + 1);
    final T value = result[rand];
    result[rand] = result[index];
    result[index] = value;
  }

  return result;
}
