List<T> slice<T>(List<T> list, [int start = 0, int end]) {
  assert(list != null);

  if (start == null) {
    start = 0;
  }
  if (end == null) {
    end = list.length;
  }

  if (list.isEmpty) {
    return [];
  }

  final int len = list.length;
  if (start >= len || end <= -len) {
    return [];
  }

  if (start < -len) {
    start = 0;
  } else {
    start = start % len;
    if (start < 0) {
      start += len;
    }
  }
  if (end > len) {
    end = len;
  } else {
    end = end % len;
    if (end < 0) {
      end += len;
    }
  }
  
  if (start >= end) {
    return [];
  }

  return list.sublist(start, end);
}
