import '_helper.dart';

typedef bool _Predicator<T>(T value, [int index, List<T> list]);

List<T> takeRightWhile<T>(List<T> list, [_Predicator<T> predicator]) {
  assert(list != null);

  if (predicator == null) {
    predicator = (T value, [int index, List<T> list]) {
      return isFalsy(value);
    };
  }

  int start = list.length - 1;
  while(start >= 0 && predicator(list[start], start, list)) {
    start -= 1;
  }

  return list.sublist(start + 1, list.length);
}
