import '_helper.dart';

typedef bool _Predicator<T>(T value, [int index, List<T> list]);

List<T> takeWhile<T>(List<T> list, [_Predicator<T> predicator]) {
  assert(list != null);

  if (predicator == null) {
    predicator = (T value, [int index, List<T> list]) {
      return isFalsy(value);
    };
  }

  final len = list.length;
  int end = 0;
  while(end < len && predicator(list[end], end, list)) {
    end += 1;
  }

  return list.sublist(0, end);
}
