import '_helper.dart';
import 'uniq.dart';

List<T> uniqWith<T>(List<T> list, [Comparator comparator]) {
  assert(list != null);

  if (comparator == null) {
    return uniq(list);
  }

  final Set<T> set = Set();

  outer:
  for (T item in list) {
    for (T value in set) {
      if (comparator(item, value)) {
        continue outer;
      }
    }
    set.add(item);
  }

  return set.toList();
}
