import 'package:test/test.dart';
import '../lib/src/chunk.dart';

void main() {
  List<int> array = [0, 1, 2, 3, 4, 5];

  group('chunk', () {
    test('should return chunked arrays', () {
      List<List<int>> actual = chunk<int>(array, 3);
      expect(actual, equals([[0, 1, 2], [3, 4, 5]]));
    });

    test('should return the last chunk as remaining elements', () {
      List<List<int>> actual = chunk<int>(array, 4);
      expect(actual, equals([[0, 1, 2, 3], [4, 5]]));
    });

    test('should coerce `size` to an integer', () {
      expect(
        chunk<int>(array, array.length ~/ 4),
        equals([[0], [1], [2], [3], [4], [5]])
      );
    });
  });
}
