import 'dart:math';

import 'package:test/test.dart';
import '../lib/src/difference.dart';

void main() {
  List<int> array1 = [5, 1, 2, 3, 4];
  List<int> array2 = [2, 3, 4];
  group('difference', () {
    test('should return differences of two arrays', () {
      List actual = difference(array1, array2);
      expect(actual, equals([5, 1]));
    });

    test('should return [] when first array is empty', () {
      List actual = difference([], array2);
      expect(actual, equals([]));
    });

    test('should return array1 when second array is empty', () {
      List<int> array1 = [];
      Random random = Random();
      for (int i = 0; i < 100; i++) {
        array1.add(random.nextInt(1000));
      }
      List<int> actual = difference(array1, []);
      expect(actual, equals(actual));
    });
  });
}
