import 'package:test/test.dart';
import '../lib/src/differenceBy.dart';

void main() {
  group('differenceBy', () {
    test('should can ignore `iteratee`', () {
      List<double> actual = differenceBy<double>([2.1, 1.2], [2.3, 3.4]);
      expect(actual, [2.1, 1.2]);
    });

    test('should accept an `iteratee`', () {
      List<double> actual = differenceBy<double>([2.1, 1.2], [2.3, 3.4], (double num) {
        return num.floor();
      });
      expect(actual, [1.2]);
    });

    test('should retain all origin values', () {
      List<double> actual = differenceBy<double>([1.2, 2.1, 1.2], [2.3, 3.4], (double num) {
        return num.floor();
      });
      expect(actual, [1.2, 1.2]);
    });
  });
}
