import 'package:test/test.dart';
import '../lib/src/differenceWith.dart';

void main() {
  group('differenceWith', () {
    test('should can ignore `comparator`', () {
      List<double> actual = differenceWith<double>([2.1, 1.2], [2.3, 3.4]);
      expect(actual, [2.1, 1.2]);
    });

    test('should work with a `comparator`', () {
      List<Map<String, int>> objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
      List<Map<String, int>> actual = differenceWith(
        objects,
        [{ 'x': 1, 'y': 2 }],
        (Map<String, int> left, Map<String, int> right) {
          return left['x'] == right['x'] && left['y'] == right['y'];
        }
      );

      expect(actual, [objects[1]]);
    });

    test('should retain all origin values', () {
      List<double> actual = differenceWith<double>([1.2, 2.1, 1.2], [2.3, 3.4], (double left, double right) {
        return left.floor() == right.floor();
      });
      expect(actual, [1.2, 1.2]);
    });
  });
}
