import 'dart:math';

import 'package:test/test.dart';
import '../lib/src/drop.dart';

void main() {
  group('drop', () {
    List<int> array = [1, 2, 3];

    test('should drop the first two elements', () {
      expect(
        drop(array, 2),
        [3]
      );
    });

    test('should return all elements when `n` < `1`', () {
      [0, -1].forEach((n) {
        expect(drop(array, n), array);
      });
    });

    test('should return an empty array when `n` >= `length`', () {
      [3, 4, pow(2, 32)].forEach((n) {
        expect(drop(array, n), []);
      });
    });
  });
}
