import 'dart:math';

import 'package:test/test.dart';
import '../lib/src/dropRight.dart';

void main() {
  group('dropRight', () {
    List<int> array = [1, 2, 3];

    test('should drop the last two elements', () {
      expect(
        dropRight(array, 2),
        [1]
      );
    });

    test('should return all elements when `n` < 1', () {
      [0, -1].forEach((n) {
        expect(dropRight(array, n), array);
      });
    });

    test('should return an empty array when `n` >= `length`', () {
      [3, 4, pow(2, 32)].forEach((n) {
        expect(dropRight(array, n), []);
      });
    });
  });
}
